#include <cmath>
using namespace std;

#ifdef __INTEL_COMPILER
  #pragma message(" ##########  Use of MKL  ###############")
  #include <mkl.h>                 // MKL
#else
  #pragma message(" ##########  Use of CBLAS  ###############")
extern "C"
{
  #include <cblas.h>               // cBLAS Library
}
#endif

#include <omp.h>                // OpenMP

#include "mylib.h"


double scalar(const unsigned int N, const double x[], const double y[])
{
 double sum = 0.0;
 unsigned int i;
#pragma omp parallel for private(i) shared(x,y) schedule(static) reduction(+:sum)
//#pragma acc parallel loop reduction(+:sum) pcopyin(x[0:N],y[0:N])
#pragma acc parallel loop num_gangs(2) vector_length(192) reduction(+:sum) pcopyin(x[0:N],y[0:N])
 for (i=0; i<N; ++i)
 {
    sum += x[i]*y[i];
 }
 return sum;
}

double scalar_blas(const unsigned int N, const double x[], const double y[])
{
 //return cblas_ddot(N,x,1,y,1);
}

